OGRE: Ogre::v1::TagPoint Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ogre::v1::TagPoint Class Reference
Core » Animation

A tagged point on a skeleton, which can be used to attach entities to on specific other entities. More...

`#include <OgreTagPoint.h>`

Inheritance diagram for Ogre::v1::TagPoint:
[legend]

## Public Types
typedef MapIterator< ChildOldNodeMap > | ChildOldNodeIterator
typedef unordered_map< String, OldNode * >::type | ChildOldNodeMap
typedef ConstMapIterator< ChildOldNodeMap > | ConstChildOldNodeIterator
enum | TransformSpace { TS_LOCAL, TS_PARENT, TS_WORLD }
| Enumeration denoting the spaces which a transform can be relative to. More...

## Public Member Functions
| TagPoint (unsigned short handle, Skeleton *creator)
virtual | ~TagPoint ()
const Quaternion & | _getBindingPoseInverseOrientation (void) const
| Gets the inverted binding pose orientation. More...
const Vector3 & | _getBindingPoseInversePosition (void) const
| Gets the inverted binding pose position. More...
const Vector3 & | _getBindingPoseInverseScale (void) const
| Gets the inverted binding pose scale. More...
virtual const Quaternion & | _getDerivedOrientation (void) const
| Gets the orientation of the OldNode as derived from all parents. More...
virtual const Vector3 & | _getDerivedPosition (void) const
| Gets the position of the OldNode as derived from all parents. More...
virtual const Vector3 & | _getDerivedScale (void) const
| Gets the scaling factor of the OldNode as derived from all parents. More...
const Matrix4 & | _getFullLocalTransform (void) const
| Gets the transform of this node just for the skeleton (not entity) More...
virtual const Matrix4 & | _getFullTransform (void) const
| Gets the full transformation matrix for this OldNode. More...
void | _getOffsetTransform (Matrix4 &m) const
| Gets the transform which takes bone space to current from the binding pose. More...
virtual void | _setDerivedOrientation (const Quaternion &q)
| Sets the final world orientation of the OldNode directly. More...
virtual void | _setDerivedPosition (const Vector3 &pos)
| Sets the final world position of the OldNode directly. More...
virtual void | _update (bool updateChildren, bool parentHasChanged)
| Internal method to update the OldNode. More...
virtual void | addChild (OldNode *child)
| Adds a (precreated) child scene OldNode to this OldNode. More...
virtual void | cancelUpdate (OldNode *child)
| Called by children to notify their parent that they no longer need an update. More...
virtual Quaternion | convertLocalToWorldOrientation (const Quaternion &localOrientation)
| Gets the world orientation of an orientation in the OldNode local space useful for simple transforms that don't require a child OldNode. More...
virtual Vector3 | convertLocalToWorldPosition (const Vector3 &localPos)
| Gets the world position of a point in the OldNode local space useful for simple transforms that don't require a child OldNode. More...
virtual Quaternion | convertWorldToLocalOrientation (const Quaternion &worldOrientation)
| Gets the local orientation, relative to this OldNode, of the given world-space orientation. More...
virtual Vector3 | convertWorldToLocalPosition (const Vector3 &worldPos)
| Gets the local position, relative to this OldNode, of the given world-space position. More...
virtual OldNode * | createChild (const String &name, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates a new named OldNode as a child of this OldNode. More...
virtual OldNode * | createChild (const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates an unnamed new OldNode as a child of this OldNode. More...
OldBone * | createChild (unsigned short handle, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates a new OldBone as a child of this bone. More...
virtual OldNode * | getChild (const String &name) const
| Gets a pointer to a named child OldNode. More...
virtual OldNode * | getChild (unsigned short index) const
| Gets a pointer to a child OldNode. More...
virtual ChildOldNodeIterator | getChildIterator (void)
| Retrieves an iterator for efficiently looping through all children of this OldNode. More...
virtual ConstChildOldNodeIterator | getChildIterator (void) const
| Retrieves an iterator for efficiently looping through all children of this OldNode. More...
MovableObject * | getChildObject (void) const
unsigned short | getHandle (void) const
| Gets the numeric handle for this bone (unique within the skeleton). More...
virtual bool | getInheritOrientation (void) const
| Returns true if this OldNode is affected by orientation applied to the parent OldNode. More...
bool | getInheritParentEntityOrientation (void) const
| Returns true if this TagPoint is affected by orientation applied to the parent entity. More...
bool | getInheritParentEntityScale (void) const
| Returns true if this TagPoint is affected by scaling factors applied to the parent entity. More...
virtual bool | getInheritScale (void) const
| Returns true if this OldNode is affected by scaling factors applied to the parent OldNode. More...
virtual const Quaternion & | getInitialOrientation (void) const
| Gets the initial orientation of this OldNode, see setInitialState for more info. More...
virtual const Vector3 & | getInitialPosition (void) const
| Gets the initial position of this OldNode, see setInitialState for more info. More...
virtual const Vector3 & | getInitialScale (void) const
| Gets the initial position of this OldNode, see setInitialState for more info. More...
const LightList & | getLights (void) const
| Gets a list of lights, ordered relative to how close they are to this renderable. More...
virtual Listener * | getListener (void) const
| Gets the current listener for this OldNode. More...
virtual Matrix3 | getLocalAxes (void) const
| Gets a matrix whose columns are the local axes based on the OldNodes orientation relative to it's parent. More...
const String & | getName (void) const
| Returns the name of the OldNode. More...
virtual const Quaternion & | getOrientation () const
| Returns a quaternion representing the OldNodes orientation. More...
virtual OldNode * | getParent (void) const
| Gets this OldNode's parent (NULL if this is the root). More...
Entity * | getParentEntity (void) const
const Matrix4 & | getParentEntityTransform (void) const
| Gets the transform of parent entity. More...
virtual const Vector3 & | getPosition (void) const
| Gets the position of the OldNode relative to it's parent. More...
virtual const Vector3 & | getScale (void) const
| Gets the scaling factor of this OldNode. More...
virtual Real | getSquaredViewDepth (const Camera *cam) const
| Helper function, get the squared view depth. More...
virtual const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
bool | isManuallyControlled () const
| Getter for mManuallyControlled Flag. More...
void | needUpdate (bool forceParentUpdate=false)
virtual unsigned short | numChildren (void) const
| Reports the number of child OldNodes under this one. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | pitch (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the OldNode around the X-axis. More...
virtual void | removeAllChildren (void)
| Removes all child OldNodes attached to this OldNode. More...
virtual OldNode * | removeChild (const String &name)
| Drops the named child from this OldNode. More...
virtual OldNode * | removeChild (OldNode *child)
| Drops the specified child from this OldNode. More...
virtual OldNode * | removeChild (unsigned short index)
| Drops the specified child from this OldNode. More...
virtual void | requestUpdate (OldNode *child, bool forceParentUpdate=false)
| Called by children to notify their parent that they need an update. More...
void | reset (void)
| Resets the position and orientation of this OldBone to the original binding position. More...
virtual void | resetOrientation (void)
| Resets the OldNodes orientation (local axes as world axes, no rotation). More...
virtual void | resetToInitialState (void)
| Resets the position / orientation / scale of this OldNode to it's initial state, see setInitialState for more info. More...
virtual void | roll (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the OldNode around the Z-axis. More...
virtual void | rotate (const Quaternion &q, TransformSpace relativeTo=TS_LOCAL)
| Rotate the OldNode around an aritrary axis using a Quarternion. More...
virtual void | rotate (const Vector3 &axis, const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the OldNode around an arbitrary axis. More...
virtual void | scale (const Vector3 &scale)
| Scales the OldNode, combining it's current scale with the passed in scaling factor. More...
virtual void | scale (Real x, Real y, Real z)
| Scales the OldNode, combining it's current scale with the passed in scaling factor. More...
void | setBindingPose (void)
| Sets the current position / orientation to be the 'binding pose' ie the layout in which bones were originally bound to a mesh. More...
void | setChildObject (MovableObject *pObject)
virtual void | setInheritOrientation (bool inherit)
| Tells the OldNode whether it should inherit orientation from it's parent OldNode. More...
void | setInheritParentEntityOrientation (bool inherit)
| Tells the TagPoint whether it should inherit orientation from it's parent entity. More...
void | setInheritParentEntityScale (bool inherit)
| Tells the TagPoint whether it should inherit scaling factors from it's parent entity. More...
virtual void | setInheritScale (bool inherit)
| Tells the OldNode whether it should inherit scaling factors from it's parent OldNode. More...
virtual void | setInitialState (void)
| Sets the current transform of this OldNode to be the 'initial state' ie that position / orientation / scale to be used as a basis for delta values used in keyframe animation. More...
virtual void | setListener (Listener *listener)
| Sets a listener for this OldNode. More...
void | setManuallyControlled (bool manuallyControlled)
| Sets whether or not this bone is manually controlled. More...
virtual void | setOrientation (const Quaternion &q)
| Sets the orientation of this OldNode via a quaternion. More...
virtual void | setOrientation (Real w, Real x, Real y, Real z)
| Sets the orientation of this OldNode via quaternion parameters. More...
void | setParentEntity (Entity *pEntity)
virtual void | setPosition (const Vector3 &pos)
| Sets the position of the OldNode relative to it's parent. More...
virtual void | setPosition (Real x, Real y, Real z)
| Sets the position of the OldNode relative to it's parent. More...
virtual void | setScale (const Vector3 &scale)
| Sets the scaling factor applied to this OldNode. More...
virtual void | setScale (Real x, Real y, Real z)
| Sets the scaling factor applied to this OldNode. More...
virtual void | setUserAny (const Any &anything)
virtual void | translate (const Matrix3 &axes, const Vector3 &move, TransformSpace relativeTo=TS_PARENT)
| Moves the OldNode along arbitrary axes. More...
virtual void | translate (const Matrix3 &axes, Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| Moves the OldNode along arbitrary axes. More...
virtual void | translate (const Vector3 &d, TransformSpace relativeTo=TS_PARENT)
| Moves the OldNode along the Cartesian axes. More...
virtual void | translate (Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| Moves the OldNode along the Cartesian axes. More...
void | updateFromParentImpl (void) const
| Overridden from Node in order to include parent Entity transform. More...
virtual void | yaw (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the OldNode around the Y-axis. More...

## Static Public Member Functions
static void | processQueuedUpdates (void)
| Process queued 'needUpdate' calls. More...
static void | queueNeedUpdate (OldNode *n)
| Queue a 'needUpdate' call to a OldNode safely. More...

## Detailed Description

A tagged point on a skeleton, which can be used to attach entities to on specific other entities.

Remarks
  A Skeleton, like a Mesh, is shared between Entity objects and simply updated as required when it comes to rendering. However there are times when you want to attach another object to an animated entity, and make sure that attachment follows the parent entity's animation (for example, a character holding a gun in his / her hand). This class simply identifies attachment points on a skeleton which can be used to attach child objects.

  The child objects themselves are not physically attached to this class; as it's name suggests this class just 'tags' the area. The actual child objects are attached to the Entity using the skeleton which has this tag point. Use the Entity::attachMovableObjectToBone method to attach the objects, which creates a new TagPoint on demand.

## Member Typedef Documentation

## ◆ ChildOldNodeIterator

typedef MapIterator<ChildOldNodeMap> Ogre::v1::OldNode::ChildOldNodeIterator
| inherited

## ◆ ChildOldNodeMap

typedef unordered_map<String, OldNode*>::type Ogre::v1::OldNode::ChildOldNodeMap
| inherited

## ◆ ConstChildOldNodeIterator

typedef ConstMapIterator<ChildOldNodeMap> Ogre::v1::OldNode::ConstChildOldNodeIterator
| inherited

## Member Enumeration Documentation

## ◆ TransformSpace

enum Ogre::v1::OldNode::TransformSpace
| inherited

Enumeration denoting the spaces which a transform can be relative to.

Enumerator
TS_LOCAL | Transform is relative to the local space.
TS_PARENT | Transform is relative to the space of the parent OldNode.
TS_WORLD | Transform is relative to world space.

## Constructor & Destructor Documentation

## ◆ TagPoint()

Ogre::v1::TagPoint::TagPoint | ( | unsigned short | handle,
|  | Skeleton * | creator
| ) |  |

## ◆ ~TagPoint()

virtual Ogre::v1::TagPoint::~TagPoint | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _getBindingPoseInverseOrientation()

const Quaternion& Ogre::v1::OldBone::_getBindingPoseInverseOrientation | ( | void |  | ) | const
| inlineinherited

Gets the inverted binding pose orientation.

## ◆ _getBindingPoseInversePosition()

const Vector3& Ogre::v1::OldBone::_getBindingPoseInversePosition | ( | void |  | ) | const
| inlineinherited

Gets the inverted binding pose position.

## ◆ _getBindingPoseInverseScale()

const Vector3& Ogre::v1::OldBone::_getBindingPoseInverseScale | ( | void |  | ) | const
| inlineinherited

Gets the inverted binding pose scale.

## ◆ _getDerivedOrientation()

virtual const Quaternion& Ogre::v1::OldNode::_getDerivedOrientation | ( | void |  | ) | const
| virtualinherited

Gets the orientation of the OldNode as derived from all parents.

## ◆ _getDerivedPosition()

virtual const Vector3& Ogre::v1::OldNode::_getDerivedPosition | ( | void |  | ) | const
| virtualinherited

Gets the position of the OldNode as derived from all parents.

## ◆ _getDerivedScale()

virtual const Vector3& Ogre::v1::OldNode::_getDerivedScale | ( | void |  | ) | const
| virtualinherited

Gets the scaling factor of the OldNode as derived from all parents.

## ◆ _getFullLocalTransform()

const Matrix4& Ogre::v1::TagPoint::_getFullLocalTransform | ( | void |  | ) | const

Gets the transform of this node just for the skeleton (not entity)

## ◆ _getFullTransform()

virtual const Matrix4& Ogre::v1::OldNode::_getFullTransform | ( | void |  | ) | const
| virtualinherited

Gets the full transformation matrix for this OldNode.

Remarks
  This method returns the full transformation matrix for this OldNode, including the effect of any parent OldNode transformations, provided they have been updated using the OldNode::_update method. This should only be called by a SceneManager which knows the derived transforms have been updated before calling this method. Applications using Ogre should just use the relative transforms.

## ◆ _getOffsetTransform()

void Ogre::v1::OldBone::_getOffsetTransform | ( | Matrix4 & | m | ) | const
| inherited

Gets the transform which takes bone space to current from the binding pose.

Remarks
  Internal use only.

## ◆ _setDerivedOrientation()

virtual void Ogre::v1::OldNode::_setDerivedOrientation | ( | const Quaternion & | q | ) |
| virtualinherited

Sets the final world orientation of the OldNode directly.

Remarks
  It's advisable to use the local setOrientation if possible, this simply does the conversion for you.

## ◆ _setDerivedPosition()

virtual void Ogre::v1::OldNode::_setDerivedPosition | ( | const Vector3 & | pos | ) |
| virtualinherited

Sets the final world position of the OldNode directly.

Remarks
  It's advisable to use the local setPosition if possible

## ◆ _update()

virtual void Ogre::v1::OldNode::_update | ( | bool | updateChildren,
|  | bool | parentHasChanged
| ) |  |
| virtualinherited

Internal method to update the OldNode.

Note
  Updates this OldNode and any relevant children to incorporate transforms etc. Don't call this yourself unless you are writing a SceneManager implementation.

Parameters

  updateChildren | If `true`, the update cascades down to all children. Specify false if you wish to update children separately, e.g. because of a more selective SceneManager implementation.
  parentHasChanged | This flag indicates that the parent transform has changed, so the child should retrieve the parent's transform and combine it with its own even if it hasn't changed itself.

## ◆ addChild()

virtual void Ogre::v1::OldNode::addChild | ( | OldNode * | child | ) |
| virtualinherited

Adds a (precreated) child scene OldNode to this OldNode.

If it is attached to another OldNode, it must be detached first.

Parameters

  child | The OldNode which is to become a child OldNode of this one

## ◆ cancelUpdate()

virtual void Ogre::v1::OldNode::cancelUpdate | ( | OldNode * | child | ) |
| virtualinherited

Called by children to notify their parent that they no longer need an update.

## ◆ convertLocalToWorldOrientation()

virtual Quaternion Ogre::v1::OldNode::convertLocalToWorldOrientation | ( | const Quaternion & | localOrientation | ) |
| virtualinherited

Gets the world orientation of an orientation in the OldNode local space useful for simple transforms that don't require a child OldNode.

## ◆ convertLocalToWorldPosition()

virtual Vector3 Ogre::v1::OldNode::convertLocalToWorldPosition | ( | const Vector3 & | localPos | ) |
| virtualinherited

Gets the world position of a point in the OldNode local space useful for simple transforms that don't require a child OldNode.

## ◆ convertWorldToLocalOrientation()

virtual Quaternion Ogre::v1::OldNode::convertWorldToLocalOrientation | ( | const Quaternion & | worldOrientation | ) |
| virtualinherited

Gets the local orientation, relative to this OldNode, of the given world-space orientation.

## ◆ convertWorldToLocalPosition()

virtual Vector3 Ogre::v1::OldNode::convertWorldToLocalPosition | ( | const Vector3 & | worldPos | ) |
| virtualinherited

Gets the local position, relative to this OldNode, of the given world-space position.

## ◆ createChild() [1/3]

virtual OldNode* Ogre::v1::OldNode::createChild | ( | const String & | name,
|  | const Vector3 & | translate = `Vector3::ZERO`,
|  | const Quaternion & | rotate = `Quaternion::IDENTITY`
| ) |  |
| virtualinherited

Creates a new named OldNode as a child of this OldNode.

Remarks
  This creates a child OldNode with a given name, which allows you to look the OldNode up from the parent which holds this collection of OldNodes.

Parameters

  translate | Initial translation offset of child relative to parent
  rotate | Initial rotation relative to parent

## ◆ createChild() [2/3]

virtual OldNode* Ogre::v1::OldNode::createChild | ( | const Vector3 & | translate = `Vector3::ZERO`,
|  | const Quaternion & | rotate = `Quaternion::IDENTITY`
| ) |  |
| virtualinherited

Creates an unnamed new OldNode as a child of this OldNode.

Parameters

  translate | Initial translation offset of child relative to parent
  rotate | Initial rotation relative to parent

## ◆ createChild() [3/3]

OldBone* Ogre::v1::OldBone::createChild | ( | unsigned short | handle,
|  | const Vector3 & | translate = `Vector3::ZERO`,
|  | const Quaternion & | rotate = `Quaternion::IDENTITY`
| ) |  |
| inherited

Creates a new OldBone as a child of this bone.

Remarks
  This method creates a new bone which will inherit the transforms of this bone, with the handle specified.

Parameters

  handle | The numeric handle to give the new bone; must be unique within the Skeleton.
  translate | Initial translation offset of child relative to parent
  rotate | Initial rotation relative to parent

## ◆ getChild() [1/2]

virtual OldNode* Ogre::v1::OldNode::getChild | ( | const String & | name | ) | const
| virtualinherited

Gets a pointer to a named child OldNode.

## ◆ getChild() [2/2]

virtual OldNode* Ogre::v1::OldNode::getChild | ( | unsigned short | index | ) | const
| virtualinherited

Gets a pointer to a child OldNode.

Remarks
  There is an alternate getChild method which returns a named child.

## ◆ getChildIterator() [1/2]

virtual ChildOldNodeIterator Ogre::v1::OldNode::getChildIterator | ( | void |  | ) |
| virtualinherited

Retrieves an iterator for efficiently looping through all children of this OldNode.

Remarks
  Using this is faster than repeatedly calling getChild if you want to go through all (or most of) the children of this OldNode. Note that the returned iterator is only valid whilst no children are added or removed from this OldNode. Thus you should not store this returned iterator for later use, nor should you add / remove children whilst iterating through it; store up changes for later. Note that calling methods on returned items in the iterator IS allowed and does not invalidate the iterator.

## ◆ getChildIterator() [2/2]

virtual ConstChildOldNodeIterator Ogre::v1::OldNode::getChildIterator | ( | void |  | ) | const
| virtualinherited

Retrieves an iterator for efficiently looping through all children of this OldNode.

Remarks
  Using this is faster than repeatedly calling getChild if you want to go through all (or most of) the children of this OldNode. Note that the returned iterator is only valid whilst no children are added or removed from this OldNode. Thus you should not store this returned iterator for later use, nor should you add / remove children whilst iterating through it; store up changes for later. Note that calling methods on returned items in the iterator IS allowed and does not invalidate the iterator.

## ◆ getChildObject()

MovableObject* Ogre::v1::TagPoint::getChildObject | ( | void |  | ) | const

## ◆ getHandle()

unsigned short Ogre::v1::OldBone::getHandle | ( | void |  | ) | const
| inherited

Gets the numeric handle for this bone (unique within the skeleton).

## ◆ getInheritOrientation()

virtual bool Ogre::v1::OldNode::getInheritOrientation | ( | void |  | ) | const
| virtualinherited

Returns true if this OldNode is affected by orientation applied to the parent OldNode.

Remarks
  Orientations, unlike other transforms, are not always inherited by child OldNodes. Whether or not orientations affect the orientation of the child OldNodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent OldNode to apply to a child OldNode (e.g. where the child OldNode is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child OldNode is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.
  See setInheritOrientation for more info.

## ◆ getInheritParentEntityOrientation()

bool Ogre::v1::TagPoint::getInheritParentEntityOrientation | ( | void |  | ) | const

Returns true if this TagPoint is affected by orientation applied to the parent entity.

## ◆ getInheritParentEntityScale()

bool Ogre::v1::TagPoint::getInheritParentEntityScale | ( | void |  | ) | const

Returns true if this TagPoint is affected by scaling factors applied to the parent entity.

## ◆ getInheritScale()

virtual bool Ogre::v1::OldNode::getInheritScale | ( | void |  | ) | const
| virtualinherited

Returns true if this OldNode is affected by scaling factors applied to the parent OldNode.

Remarks
  See setInheritScale for more info.

## ◆ getInitialOrientation()

virtual const Quaternion& Ogre::v1::OldNode::getInitialOrientation | ( | void |  | ) | const
| virtualinherited

Gets the initial orientation of this OldNode, see setInitialState for more info.

## ◆ getInitialPosition()

virtual const Vector3& Ogre::v1::OldNode::getInitialPosition | ( | void |  | ) | const
| virtualinherited

Gets the initial position of this OldNode, see setInitialState for more info.

Remarks
  Also resets the cumulative animation weight used for blending.

## ◆ getInitialScale()

virtual const Vector3& Ogre::v1::OldNode::getInitialScale | ( | void |  | ) | const
| virtualinherited

Gets the initial position of this OldNode, see setInitialState for more info.

## ◆ getLights()

const LightList& Ogre::v1::TagPoint::getLights | ( | void |  | ) | const

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

## ◆ getListener()

virtual Listener* Ogre::v1::OldNode::getListener | ( | void |  | ) | const
| inlinevirtualinherited

Gets the current listener for this OldNode.

## ◆ getLocalAxes()

virtual Matrix3 Ogre::v1::OldNode::getLocalAxes | ( | void |  | ) | const
| virtualinherited

Gets a matrix whose columns are the local axes based on the OldNodes orientation relative to it's parent.

## ◆ getName()

const String& Ogre::v1::OldNode::getName | ( | void |  | ) | const
| inherited

Returns the name of the OldNode.

## ◆ getOrientation()

virtual const Quaternion& Ogre::v1::OldNode::getOrientation | ( |  | ) | const
| virtualinherited

Returns a quaternion representing the OldNodes orientation.

## ◆ getParent()

virtual OldNode* Ogre::v1::OldNode::getParent | ( | void |  | ) | const
| virtualinherited

Gets this OldNode's parent (NULL if this is the root).

## ◆ getParentEntity()

Entity* Ogre::v1::TagPoint::getParentEntity | ( | void |  | ) | const

## ◆ getParentEntityTransform()

const Matrix4& Ogre::v1::TagPoint::getParentEntityTransform | ( | void |  | ) | const

Gets the transform of parent entity.

## ◆ getPosition()

virtual const Vector3& Ogre::v1::OldNode::getPosition | ( | void |  | ) | const
| virtualinherited

Gets the position of the OldNode relative to it's parent.

## ◆ getScale()

virtual const Vector3& Ogre::v1::OldNode::getScale | ( | void |  | ) | const
| virtualinherited

Gets the scaling factor of this OldNode.

## ◆ getSquaredViewDepth()

virtual Real Ogre::v1::OldNode::getSquaredViewDepth | ( | const Camera * | cam | ) | const
| virtualinherited

Helper function, get the squared view depth.

## ◆ getUserAny()

virtual const Any& Ogre::v1::OldNode::getUserAny | ( | void |  | ) | const
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead. Retrieves the custom user value associated with this object.

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings& Ogre::v1::OldNode::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings& Ogre::v1::OldNode::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ isManuallyControlled()

bool Ogre::v1::OldBone::isManuallyControlled | ( |  | ) | const
| inherited

Getter for mManuallyControlled Flag.

## ◆ needUpdate()

void Ogre::v1::TagPoint::needUpdate | ( | bool | forceParentUpdate = `false` | ) |
| virtual

Reimplemented from Ogre::v1::OldBone.

## ◆ numChildren()

virtual unsigned short Ogre::v1::OldNode::numChildren | ( | void |  | ) | const
| virtualinherited

Reports the number of child OldNodes under this one.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ pitch()

virtual void Ogre::v1::OldNode::pitch | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) |  |
| virtualinherited

Rotate the OldNode around the X-axis.

## ◆ processQueuedUpdates()

static void Ogre::v1::OldNode::processQueuedUpdates | ( | void |  | ) |
| staticinherited

Process queued 'needUpdate' calls.

## ◆ queueNeedUpdate()

static void Ogre::v1::OldNode::queueNeedUpdate | ( | OldNode * | n | ) |
| staticinherited

Queue a 'needUpdate' call to a OldNode safely.

Remarks
  You can't call needUpdate() during the scene graph update, e.g. in response to a OldNode::Listener hook, because the graph is already being updated, and update flag changes cannot be made reliably in that context. Call this method if you need to queue a needUpdate call in this case.

## ◆ removeAllChildren()

virtual void Ogre::v1::OldNode::removeAllChildren | ( | void |  | ) |
| virtualinherited

Removes all child OldNodes attached to this OldNode.

Does not delete the OldNodes, just detaches them from this parent, potentially to be reattached elsewhere.

## ◆ removeChild() [1/3]

virtual OldNode* Ogre::v1::OldNode::removeChild | ( | const String & | name | ) |
| virtualinherited

Drops the named child from this OldNode.

Remarks
  Does not delete the OldNode, just detaches it from this parent, potentially to be reattached elsewhere.

## ◆ removeChild() [2/3]

virtual OldNode* Ogre::v1::OldNode::removeChild | ( | OldNode * | child | ) |
| virtualinherited

Drops the specified child from this OldNode.

Remarks
  Does not delete the OldNode, just detaches it from this parent, potentially to be reattached elsewhere. There is also an alternate version which drops a named child from this OldNode.

## ◆ removeChild() [3/3]

virtual OldNode* Ogre::v1::OldNode::removeChild | ( | unsigned short | index | ) |
| virtualinherited

Drops the specified child from this OldNode.

Remarks
  Does not delete the OldNode, just detaches it from this parent, potentially to be reattached elsewhere. There is also an alternate version which drops a named child from this OldNode.

## ◆ requestUpdate()

virtual void Ogre::v1::OldNode::requestUpdate | ( | OldNode * | child,
|  | bool | forceParentUpdate = `false`
| ) |  |
| virtualinherited

Called by children to notify their parent that they need an update.

Parameters

  forceParentUpdate | Even if the OldNode thinks it has already told it's parent, tell it anyway

## ◆ reset()

void Ogre::v1::OldBone::reset | ( | void |  | ) |
| inherited

Resets the position and orientation of this OldBone to the original binding position.

Remarks
  Bones are bound to the mesh in a binding pose. They are then modified from this position during animation. This method returns the bone to it's original position and orientation.

## ◆ resetOrientation()

virtual void Ogre::v1::OldNode::resetOrientation | ( | void |  | ) |
| virtualinherited

Resets the OldNodes orientation (local axes as world axes, no rotation).

Remarks
  Orientations, unlike other transforms, are not always inherited by child OldNodes. Whether or not orientations affect the orientation of the child OldNodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent OldNode to apply to a child OldNode (e.g. where the child OldNode is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child OldNode is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the OldNode's origin.

## ◆ resetToInitialState()

virtual void Ogre::v1::OldNode::resetToInitialState | ( | void |  | ) |
| virtualinherited

Resets the position / orientation / scale of this OldNode to it's initial state, see setInitialState for more info.

## ◆ roll()

virtual void Ogre::v1::OldNode::roll | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) |  |
| virtualinherited

Rotate the OldNode around the Z-axis.

## ◆ rotate() [1/2]

virtual void Ogre::v1::OldNode::rotate | ( | const Quaternion & | q,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) |  |
| virtualinherited

Rotate the OldNode around an aritrary axis using a Quarternion.

## ◆ rotate() [2/2]

virtual void Ogre::v1::OldNode::rotate | ( | const Vector3 & | axis,
|  | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) |  |
| virtualinherited

Rotate the OldNode around an arbitrary axis.

## ◆ scale() [1/2]

virtual void Ogre::v1::OldNode::scale | ( | const Vector3 & | scale | ) |
| virtualinherited

Scales the OldNode, combining it's current scale with the passed in scaling factor.

Remarks
  This method applies an extra scaling factor to the OldNode's existing scale, (unlike setScale which overwrites it) combining it's current scale with the new one. E.g. calling this method twice with Vector3(2,2,2) would have the same effect as setScale(Vector3(4,4,4)) if the existing scale was 1.

  Note that like rotations, scalings are oriented around the OldNode's origin.

## ◆ scale() [2/2]

virtual void Ogre::v1::OldNode::scale | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |  |
| virtualinherited

Scales the OldNode, combining it's current scale with the passed in scaling factor.

Remarks
  This method applies an extra scaling factor to the OldNode's existing scale, (unlike setScale which overwrites it) combining it's current scale with the new one. E.g. calling this method twice with Vector3(2,2,2) would have the same effect as setScale(Vector3(4,4,4)) if the existing scale was 1.

  Note that like rotations, scalings are oriented around the OldNode's origin.

## ◆ setBindingPose()

void Ogre::v1::OldBone::setBindingPose | ( | void |  | ) |
| inherited

Sets the current position / orientation to be the 'binding pose' ie the layout in which bones were originally bound to a mesh.

## ◆ setChildObject()

void Ogre::v1::TagPoint::setChildObject | ( | MovableObject * | pObject | ) |

## ◆ setInheritOrientation()

virtual void Ogre::v1::OldNode::setInheritOrientation | ( | bool | inherit | ) |
| virtualinherited

Tells the OldNode whether it should inherit orientation from it's parent OldNode.

Remarks
  Orientations, unlike other transforms, are not always inherited by child OldNodes. Whether or not orientations affect the orientation of the child OldNodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent OldNode to apply to a child OldNode (e.g. where the child OldNode is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child OldNode is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

Parameters

  inherit | If true, this OldNode's orientation will be affected by its parent's orientation. If false, it will not be affected.

## ◆ setInheritParentEntityOrientation()

void Ogre::v1::TagPoint::setInheritParentEntityOrientation | ( | bool | inherit | ) |

Tells the TagPoint whether it should inherit orientation from it's parent entity.

Parameters

  inherit | If true, this TagPoint's orientation will be affected by its parent entity's orientation. If false, it will not be affected.

## ◆ setInheritParentEntityScale()

void Ogre::v1::TagPoint::setInheritParentEntityScale | ( | bool | inherit | ) |

Tells the TagPoint whether it should inherit scaling factors from it's parent entity.

Parameters

  inherit | If true, this TagPoint's scaling factors will be affected by its parent entity's scaling factors. If false, it will not be affected.

## ◆ setInheritScale()

virtual void Ogre::v1::OldNode::setInheritScale | ( | bool | inherit | ) |
| virtualinherited

Tells the OldNode whether it should inherit scaling factors from it's parent OldNode.

Remarks
  Scaling factors, unlike other transforms, are not always inherited by child OldNodes. Whether or not scalings affect the size of the child OldNodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent OldNode to apply to a child OldNode (e.g. where the child OldNode is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child OldNode is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

Parameters

  inherit | If true, this OldNode's scale will be affected by its parent's scale. If false, it will not be affected.

## ◆ setInitialState()

virtual void Ogre::v1::OldNode::setInitialState | ( | void |  | ) |
| virtualinherited

Sets the current transform of this OldNode to be the 'initial state' ie that position / orientation / scale to be used as a basis for delta values used in keyframe animation.

Remarks
  You never need to call this method unless you plan to animate this OldNode. If you do plan to animate it, call this method once you've loaded the OldNode with it's base state, ie the state on which all keyframes are based.

  If you never call this method, the initial state is the identity transform, ie do nothing.

## ◆ setListener()

virtual void Ogre::v1::OldNode::setListener | ( | Listener * | listener | ) |
| inlinevirtualinherited

Sets a listener for this OldNode.

Remarks
  Note for size and performance reasons only one listener per OldNode is allowed.

## ◆ setManuallyControlled()

void Ogre::v1::OldBone::setManuallyControlled | ( | bool | manuallyControlled | ) |
| inherited

Sets whether or not this bone is manually controlled.

Remarks
  Manually controlled bones can be altered by the application at runtime, and their positions will not be reset by the animation routines. Note that you should also make sure that there are no AnimationTrack objects referencing this bone, or if there are, you should disable them using pAnimation->destroyTrack(pBone->getHandle());

  You can also use AnimationState::setBlendMask to mask out animation from chosen tracks if you want to prevent application of a scripted animation to a bone without altering the Animation definition.

## ◆ setOrientation() [1/2]

virtual void Ogre::v1::OldNode::setOrientation | ( | const Quaternion & | q | ) |
| virtualinherited

Sets the orientation of this OldNode via a quaternion.

Remarks
  Orientations, unlike other transforms, are not always inherited by child OldNodes. Whether or not orientations affect the orientation of the child OldNodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent OldNode to apply to a child OldNode (e.g. where the child OldNode is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child OldNode is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the OldNode's origin.

## ◆ setOrientation() [2/2]

virtual void Ogre::v1::OldNode::setOrientation | ( | Real | w,
|  | Real | x,
|  | Real | y,
|  | Real | z
| ) |  |
| virtualinherited

Sets the orientation of this OldNode via quaternion parameters.

Remarks
  Orientations, unlike other transforms, are not always inherited by child OldNodes. Whether or not orientations affect the orientation of the child OldNodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent OldNode to apply to a child OldNode (e.g. where the child OldNode is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child OldNode is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the OldNode's origin.

## ◆ setParentEntity()

void Ogre::v1::TagPoint::setParentEntity | ( | Entity * | pEntity | ) |

## ◆ setPosition() [1/2]

virtual void Ogre::v1::OldNode::setPosition | ( | const Vector3 & | pos | ) |
| virtualinherited

Sets the position of the OldNode relative to it's parent.

## ◆ setPosition() [2/2]

virtual void Ogre::v1::OldNode::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |  |
| virtualinherited

Sets the position of the OldNode relative to it's parent.

## ◆ setScale() [1/2]

virtual void Ogre::v1::OldNode::setScale | ( | const Vector3 & | scale | ) |
| virtualinherited

Sets the scaling factor applied to this OldNode.

Remarks
  Scaling factors, unlike other transforms, are not always inherited by child OldNodes. Whether or not scalings affect the size of the child OldNodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent OldNode to apply to a child OldNode (e.g. where the child OldNode is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child OldNode is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

  Note that like rotations, scalings are oriented around the OldNode's origin.

## ◆ setScale() [2/2]

virtual void Ogre::v1::OldNode::setScale | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |  |
| virtualinherited

Sets the scaling factor applied to this OldNode.

Remarks
  Scaling factors, unlike other transforms, are not always inherited by child OldNodes. Whether or not scalings affect the size of the child OldNodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent OldNode to apply to a child OldNode (e.g. where the child OldNode is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child OldNode is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

  Note that like rotations, scalings are oriented around the OldNode's origin.

## ◆ setUserAny()

virtual void Ogre::v1::OldNode::setUserAny | ( | const Any & | anything | ) |
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead. Sets any kind of user value on this object.

Remarks
  This method allows you to associate any user value you like with this OldNode. This can be a pointer back to one of your own classes for instance.

## ◆ translate() [1/4]

virtual void Ogre::v1::OldNode::translate | ( | const Matrix3 & | axes,
|  | const Vector3 & | move,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) |  |
| virtualinherited

Moves the OldNode along arbitrary axes.

Remarks
  This method translates the OldNode by a vector which is relative to a custom set of axes.

Parameters

  axes | A 3x3 Matrix containing 3 column vectors each representing the axes X, Y and Z respectively. In this format the standard cartesian axes would be expressed as:
          1 0 0
          0 1 0
          0 0 1
  i.e. the identity matrix.
  move | Vector relative to the axes above.
  relativeTo | The space which this transform is relative to.

## ◆ translate() [2/4]

virtual void Ogre::v1::OldNode::translate | ( | const Matrix3 & | axes,
|  | Real | x,
|  | Real | y,
|  | Real | z,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) |  |
| virtualinherited

Moves the OldNode along arbitrary axes.

Remarks
  This method translates the OldNode by a vector which is relative to a custom set of axes.

Parameters

  axes | A 3x3 Matrix containing 3 column vectors each representing the axes X, Y and Z respectively. In this format the standard cartesian axes would be expressed as
          1 0 0
          0 1 0
          0 0 1
  i.e. the identity matrix.
  x | The `x` translation component relative to the axes above.
  y | The `y` translation component relative to the axes above.
  z | The `z` translation component relative to the axes above.
  relativeTo | The space which this transform is relative to.

## ◆ translate() [3/4]

virtual void Ogre::v1::OldNode::translate | ( | const Vector3 & | d,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) |  |
| virtualinherited

Moves the OldNode along the Cartesian axes.

  This method moves the OldNode by the supplied vector along the world Cartesian axes, i.e. along world x,y,z

Parameters

  d | Vector with x,y,z values representing the translation.
  relativeTo | The space which this transform is relative to.

## ◆ translate() [4/4]

virtual void Ogre::v1::OldNode::translate | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) |  |
| virtualinherited

Moves the OldNode along the Cartesian axes.

  This method moves the OldNode by the supplied vector along the world Cartesian axes, i.e. along world x,y,z

Parameters

  x | Real `x` value representing the translation.
  y | Real `y` value representing the translation.
  z | Real `z` value representing the translation.
  relativeTo | The space which this transform is relative to.

## ◆ updateFromParentImpl()

void Ogre::v1::TagPoint::updateFromParentImpl | ( | void |  | ) | const
| virtual

Overridden from Node in order to include parent Entity transform.

Reimplemented from Ogre::v1::OldNode.

## ◆ yaw()

virtual void Ogre::v1::OldNode::yaw | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) |  |
| virtualinherited

Rotate the OldNode around the Y-axis.

The documentation for this class was generated from the following file:

- OgreTagPoint.h